/*
*********************************************************************
          
                      Bollinger Squeeze v8
                  Original code by Nick Bilak
                   Modifications by Akuma99
                   Copyright  2006-07  Akuma99
                  http://www.beginnertrader.com  

       For help on this indicator, tutorials and information 
               visit http://www.beginnertrader.com 
                  
*********************************************************************
*/

#property copyright "Copyright  2006-07, Akuma99"
#property link      "http://www.beginnertrader.com "

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrGreen      //uptrend
#property indicator_width1  2  
#property indicator_color2  clrIndianRed  //downtrend
#property indicator_width2  2  
#property indicator_color3  clrDarkGreen // First Stochastic line
#property indicator_width3  2  


extern ENUM_TIMEFRAMES TimeFrame        = PERIOD_CURRENT;
extern int             StochPeriod      = 14;
extern int             DPeriod          = 3;
extern int             SlowingPeriod    = 3;
extern ENUM_MA_METHOD  MaMethod         = 0;
extern ENUM_STO_PRICE  StochPrice       = 0;
extern bool            ShowArrows       = false;
extern string          arrowsIdentifier = "sto Arrows";
extern double          arrowsUpperGap   = 1.0;
extern double          arrowsLowerGap   = 1.0;
extern color           arrowsUpColor    = clrLimeGreen;
extern color           arrowsDnColor    = clrRed;
extern color           arrowsUpCode     = 241;
extern color           arrowsDnCode     = 242;
extern bool            alertsOn         = true;          // Turn alerts on?
extern bool            alertsOnCurrent  = false;         // Alerts on current (still opened) bar
extern bool            alertsMessage    = true;          // Alerts should show pop-up message
extern bool            alertsSound      = false;         // Alerts should play alert sound
extern bool            alertsPushNotif  = false;         // Alerts should send push notification
extern bool            alertsEmail      = false;         // Alerts should send email

double upB[];
double loB[];
double sto[];
double trend[];
//+------------------------------------------------------------------+
int init() 
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,upB); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,loB); SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(2,sto);
   SetIndexBuffer(3,trend);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Stoch Histogram ("+StochPeriod+","+DPeriod+","+SlowingPeriod+")");
return(0);
}
int deinit()
{
  deleteArrows(); 
 return(0);
}

//
//
//
//
//

int start() 
{
int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMax(Bars-counted_bars,3*TimeFrame/Period());
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      int y  = iBarShift(NULL,TimeFrame,Time[i]);
      sto[i] = iStochastic(NULL,TimeFrame,StochPeriod,DPeriod,SlowingPeriod,MaMethod,StochPrice,MODE_MAIN,y)-50;      
      
      //
      //
      //
      //
      //
      
      upB[i]   = EMPTY_VALUE;
      loB[i]   = EMPTY_VALUE;
      trend[i] = trend[i+1];
      if(sto[i]>0) trend[i] = 1;
      if(sto[i]<0) trend[i] =-1;
      if (trend[i] == 1) upB[i] = sto[i];
      if (trend[i] ==-1) loB[i] = sto[i];   
         
      //
      //
      //
      //
      //
     
      if (ShowArrows)
      {
         deleteArrow(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
            if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
          }
       }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
    }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," StochHistogram trend changed to ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(Symbol()+" StochHistogram",message);
          if (alertsPushNotif) SendNotification(message);
          if (alertsSound)     PlaySound("alert2.wav");
   }
}



